Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/AGRIF_DEMO/EXPREF/1_namelist_cfg	(revision 14062)
@@ -299,5 +299,4 @@
 !-----------------------------------------------------------------------
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0          ! =0   e3f = mean masked e3t divided by 4
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/AGRIF_DEMO/EXPREF/namelist_cfg	(revision 14062)
@@ -300,5 +300,4 @@
 !-----------------------------------------------------------------------
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0          ! =0   e3f = mean masked e3t divided by 4
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/AMM12/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/AMM12/EXPREF/namelist_cfg	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/AMM12/EXPREF/namelist_cfg	(revision 14062)
@@ -291,5 +291,5 @@
 !-----------------------------------------------------------------------
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 1             !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
+   nn_e3f_typ = 1          !  e3f = masked averaging of e3t divided by 4 (=0) or by the sum of mask (=1)
 /
 !-----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_cfg	(revision 14062)
@@ -334,5 +334,4 @@
 !-----------------------------------------------------------------------
    ln_dynvor_een = .true.  !  energy & enstrophy scheme
-      nn_een_e3f = 0          ! =0   e3f = mean masked e3t divided by 4
 /
 !-----------------------------------------------------------------------
@@ -389,7 +388,7 @@
       !                       !                 = 3 as =2 with distinct dissipative an mixing length scale
       nn_etau     =   1       !  penetration of tke below the mixed layer (ML) due to NIWs
-                               !        = 0 none ; = 1 add a tke source below the ML
-                               !        = 2 add a tke source just at the base of the ML
-                               !        = 3 as = 1 applied on HF part of the stress           (ln_cpl=T)
+      !                       !        = 0 none ; = 1 add a tke source below the ML
+      !                       !        = 2 add a tke source just at the base of the ML
+      !                       !        = 3 as = 1 applied on HF part of the stress           (ln_cpl=T)
       ln_mxhsw    = .false.   !  surface mixing length scale = F(wave height)
 /
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/SHARED/namelist_ref
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/SHARED/namelist_ref	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/cfgs/SHARED/namelist_ref	(revision 14062)
@@ -998,8 +998,10 @@
    ln_dynvor_eeT = .false. !  energy conserving scheme (een using e3t)
    ln_dynvor_een = .false. !  energy & enstrophy scheme
-      nn_een_e3f = 0          ! =0  e3f = mi(mj(e3t))/4
-      !                       ! =1  e3f = mi(mj(e3t))/mi(mj( tmask))
+   !
    ln_dynvor_msk = .false. !  vorticity multiplied by fmask (=T)        ==>>> PLEASE DO NOT ACTIVATE
-      !                    !  (f-point vorticity schemes only)
+   !                       !  (f-point vorticity schemes only)
+   !
+   nn_e3f_typ = 0          !  type of e3f (EEN, ENE, ENS, MIX only)  =0  e3f = mi(mj(e3t))/4
+   !                       !                                         =1  e3f = mi(mj(e3t))/mi(mj( tmask))
 /
 !-----------------------------------------------------------------------
@@ -1011,4 +1013,6 @@
    ln_hpg_isf  = .false.   !  s-coordinate (sco ) adapted to isf
    ln_hpg_djc  = .false.   !  s-coordinate (Density Jacobian with Cubic polynomial)
+      ln_hpg_djc_vnh = .true.  !  hor.  bc type for djc scheme (T=von Neumann, F=linear extrapolation)
+      ln_hpg_djc_vnv = .true.  !  vert. bc type for djc scheme (T=von Neumann, F=linear extrapolation)
    ln_hpg_prj  = .false.   !  s-coordinate (Pressure Jacobian scheme)
 /
@@ -1033,4 +1037,5 @@
    !                       !  Type of the operator :
    ln_dynldf_OFF = .false.     !  No operator (i.e. no explicit diffusion)
+   nn_dynldf_typ = 0           !  =0 div-rot (default)   ;   =1 symmetric
    ln_dynldf_lap = .false.     !    laplacian operator
    ln_dynldf_blp = .false.     !  bilaplacian operator
@@ -1163,8 +1168,8 @@
    ln_mxl0     = .true.    !  surface mixing length scale = F(wind stress) (T) or not (F)
       nn_mxlice    = 2        ! type of scaling under sea-ice
-                              !    = 0 no scaling under sea-ice
-                              !    = 1 scaling with constant sea-ice thickness
-                              !    = 2 scaling with mean sea-ice thickness ( only with SI3 sea-ice model )
-                              !    = 3 scaling with maximum sea-ice thickness
+      !                       !    = 0 no scaling under sea-ice
+      !                       !    = 1 scaling with constant sea-ice thickness
+      !                       !    = 2 scaling with mean sea-ice thickness ( only with SI3 sea-ice model )
+      !                       !    = 3 scaling with maximum sea-ice thickness
       rn_mxlice   = 10.       ! max constant ice thickness value when scaling under sea-ice ( nn_mxlice=1)
    rn_mxl0     =   0.04    !  surface  buoyancy lenght scale minimum value
@@ -1173,11 +1178,11 @@
       rn_lc       =   0.15    !  coef. associated to Langmuir cells
    nn_etau     =   1       !  penetration of tke below the mixed layer (ML) due to NIWs
-                              !        = 0 none ; = 1 add a tke source below the ML
-                              !        = 2 add a tke source just at the base of the ML
-                              !        = 3 as = 1 applied on HF part of the stress           (ln_cpl=T)
+   !                          !        = 0 none ; = 1 add a tke source below the ML
+   !                          !        = 2 add a tke source just at the base of the ML
+   !                          !        = 3 as = 1 applied on HF part of the stress           (ln_cpl=T)
       rn_efr      =   0.05    !  fraction of surface tke value which penetrates below the ML (nn_etau=1 or 2)
       nn_htau     =   1       !  type of exponential decrease of tke penetration below the ML
-                              !        = 0  constant 10 m length scale
-                              !        = 1  0.5m at the equator to 30m poleward of 40 degrees
+      !                       !        = 0  constant 10 m length scale
+      !                       !        = 1  0.5m at the equator to 30m poleward of 40 degrees
    nn_eice     =   1       !  attenutaion of langmuir & surface wave breaking under ice
    !                       !           = 0 no impact of ice cover on langmuir & surface wave breaking
@@ -1216,7 +1221,9 @@
 &namzdf_osm    !   OSM vertical diffusion                               (ln_zdfosm =T)
 !-----------------------------------------------------------------------
-   ln_use_osm_la = .false.      !  Use namelist  rn_osm_la
+   ln_use_osm_la = .false.     !  Use   rn_osm_la
    rn_osm_la     = 0.3         !  Turbulent Langmuir number
-   rn_osm_dstokes     = 5.     !  Depth scale of Stokes drift (m)
+   rn_zdfosm_adjust_sd = 1.0   ! Stokes drift reduction factor
+   rn_osm_hblfrac = 0.1        ! specify top part of hbl for nn_osm_wave = 3 or 4
+   rn_osm_bl_thresh   = 5.e-5      !Threshold buoyancy for deepening of OSBL base
    nn_ave = 0                  ! choice of horizontal averaging on avt, avmu, avmv
    ln_dia_osm = .true.         ! output OSMOSIS-OBL variables
@@ -1226,10 +1233,31 @@
    rn_difri  =  0.005          ! max Ri# diffusivity at Ri_g = 0 (m^2/s)
    ln_convmix  = .true.        ! Use convective instability mixing below BL
-   rn_difconv = 1.             ! diffusivity when unstable below BL  (m2/s)
+   rn_difconv = 1. !0.01 !1.             ! diffusivity when unstable below BL  (m2/s)
+   rn_osm_dstokes     = 5.     !  Depth scale of Stokes drift (m)
    nn_osm_wave = 0             ! Method used to calculate Stokes drift
       !                        !  = 2: Use ECMWF wave fields
       !                        !  = 1: Pierson Moskowitz wave spectrum
       !                        !  = 0: Constant La# = 0.3
-/
+   nn_osm_SD_reduce = 0        ! Method used to get active Stokes drift from surface value
+      !                        !  = 0: No reduction
+                               !  = 1: use SD avged over top 10% hbl
+                               !  = 2:use surface value of SD fit to slope at rn_osm_hblfrac*hbl below surface
+   ln_zdfosm_ice_shelter = .true.  ! reduce surface SD and depth scale under ice
+   ln_osm_mle = .false.        !  Use integrated FK-OSM model
+/
+!-----------------------------------------------------------------------
+&namosm_mle    !   mixed layer eddy parametrisation (Fox-Kemper)       (default: OFF)
+!-----------------------------------------------------------------------
+   rn_osm_mle_ce       = 0.06      ! magnitude of the MLE (typical value: 0.06 to 0.08)
+   nn_osm_mle          = 0         ! MLE type: =0 standard Fox-Kemper ; =1 new formulation
+   rn_osm_mle_lf       = 5.e+3     ! typical scale of mixed layer front (meters)                      (case rn_osm_mle=0)
+   rn_osm_mle_time     = 172800.   ! time scale for mixing momentum across the mixed layer (seconds)  (case rn_osm_mle=0)
+   rn_osm_mle_lat      = 20.       ! reference latitude (degrees) of MLE coef.                        (case rn_mle=1)
+   rn_osm_mle_rho_c =    0.01      ! delta rho criterion used to calculate MLD for FK
+   rn_osm_mle_thresh  = 0.0005     ! delta b criterion used for FK MLE criterion
+   rn_osm_mle_tau     = 172800.    ! time scale for FK-OSM (seconds)  (case rn_osm_mle=0)
+   ln_osm_hmle_limit   = .false.   ! limit hmle to rn_osm_hmle_limit*hbl
+   rn_osm_hmle_limit   = 1.2
+   /
 !-----------------------------------------------------------------------
 &namzdf_mfc     !   Mass Flux Convection
@@ -1374,4 +1402,5 @@
    ln_sstnight = .false.             ! Logical switch for calculating night-time average for SST obs
    ln_bound_reject  = .false.        ! Logical to remove obs near boundaries in LAMs.
+   ln_default_fp_indegs = .true.     ! Logical: T=> averaging footprint is in degrees, F=> in metres
    ln_sla_fp_indegs = .true.         ! Logical for SLA: T=> averaging footprint is in degrees, F=> in metres
    ln_sst_fp_indegs = .true.         ! Logical for SST: T=> averaging footprint is in degrees, F=> in metres
@@ -1389,4 +1418,6 @@
    cn_gridsearchfile ='gridsearch.nc' ! Grid search file name
    rn_gridsearchres = 0.5            ! Grid search resolution
+   rn_default_avglamscl = 0.         ! Default E/W diameter of observation footprint (metres/degrees)
+   rn_default_avgphiscl = 0.         ! Default N/S diameter of observation footprint (metres/degrees)
    rn_mdtcorr  = 1.61                ! MDT  correction
    rn_mdtcutoff = 65.0               ! MDT cutoff for computed correction
@@ -1402,5 +1433,5 @@
    rn_sic_avgphiscl = 0.             ! N/S diameter of SIC observation footprint (metres/degrees)
    nn_1dint = 0                      ! Type of vertical interpolation method
-   nn_2dint = 0                      ! Default horizontal interpolation method
+   nn_2dint_default = 0              ! Default horizontal interpolation method
    nn_2dint_sla = 0                  ! Horizontal interpolation method for SLA
    nn_2dint_sst = 0                  ! Horizontal interpolation method for SST
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/doc/namelists/namobs
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/doc/namelists/namobs	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/doc/namelists/namobs	(revision 14062)
@@ -20,4 +20,5 @@
    ln_sstnight = .false.             ! Logical switch for calculating night-time average for SST obs
    ln_bound_reject  = .false.        ! Logical to remove obs near boundaries in LAMs.
+   ln_default_fp_indegs = .true.     ! Logical: T=> averaging footprint is in degrees, F=> in metres
    ln_sla_fp_indegs = .true.         ! Logical for SLA: T=> averaging footprint is in degrees, F=> in metres
    ln_sst_fp_indegs = .true.         ! Logical for SST: T=> averaging footprint is in degrees, F=> in metres
@@ -39,4 +40,6 @@
    rn_dobsini  = 00010101.000000     ! Initial date in window YYYYMMDD.HHMMSS
    rn_dobsend  = 00010102.000000     ! Final date in window YYYYMMDD.HHMMSS
+   rn_default_avglamscl = 0.         ! Default E/W diameter of observation footprint (metres/degrees)
+   rn_default_avgphiscl = 0.         ! Default N/S diameter of observation footprint (metres/degrees)
    rn_sla_avglamscl = 0.             ! E/W diameter of SLA observation footprint (metres/degrees)
    rn_sla_avgphiscl = 0.             ! N/S diameter of SLA observation footprint (metres/degrees)
@@ -48,5 +51,5 @@
    rn_sic_avgphiscl = 0.             ! N/S diameter of SIC observation footprint (metres/degrees)
    nn_1dint = 0                      ! Type of vertical interpolation method
-   nn_2dint = 0                      ! Default horizontal interpolation method
+   nn_2dint_default = 0              ! Default horizontal interpolation method
    nn_2dint_sla = 0                  ! Horizontal interpolation method for SLA
    nn_2dint_sst = 0                  ! Horizontal interpolation method for SST
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/ICE/iceistate.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/ICE/iceistate.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/ICE/iceistate.F90	(revision 14062)
@@ -21,5 +21,9 @@
    USE sbc_ice , ONLY : tn_ice, snwice_mass, snwice_mass_b
    USE eosbn2         ! equation of state
+# if defined key_qco
+   USE domqco         ! Variable volume
+# else
    USE domvvl         ! Variable volume
+# endif
    USE ice            ! sea-ice: variables
    USE ice1D          ! sea-ice: thermodynamics variables
@@ -434,45 +438,10 @@
          ssh(:,:,Kbb) = ssh(:,:,Kbb) - snwice_mass(:,:) * r1_rho0
          !
+#if defined key_qco
+         IF( .NOT.ln_linssh )   CALL dom_qco_zgr( Kbb, Kmm )        ! interpolation scale factor, depth and water column
+#else
          IF( .NOT.ln_linssh )   CALL dom_vvl_zgr( Kbb, Kmm, Kaa )   ! interpolation scale factor, depth and water column
-! !!st
-!          IF( .NOT.ln_linssh ) THEN
-!             !
-!             WHERE( ht_0(:,:) > 0 )   ;   z2d(:,:) = 1._wp + ssh(:,:,Kmm)*tmask(:,:,1) / ht_0(:,:)
-!             ELSEWHERE                ;   z2d(:,:) = 1._wp   ;   END WHERE
-!             !
-!             DO jk = 1,jpkm1                     ! adjust initial vertical scale factors
-!                e3t(:,:,jk,Kmm) = e3t_0(:,:,jk) * z2d(:,:)
-!                e3t(:,:,jk,Kbb) = e3t(:,:,jk,Kmm)
-!                e3t(:,:,jk,Kaa) = e3t(:,:,jk,Kmm)
-!             END DO
-!             !
-!             ! Reconstruction of all vertical scale factors at now and before time-steps
-!             ! =========================================================================
-!             ! Horizontal scale factor interpolations
-!             ! --------------------------------------
-!             CALL dom_vvl_interpol( e3t(:,:,:,Kbb), e3u(:,:,:,Kbb), 'U' )
-!             CALL dom_vvl_interpol( e3t(:,:,:,Kbb), e3v(:,:,:,Kbb), 'V' )
-!             CALL dom_vvl_interpol( e3t(:,:,:,Kmm), e3u(:,:,:,Kmm), 'U' )
-!             CALL dom_vvl_interpol( e3t(:,:,:,Kmm), e3v(:,:,:,Kmm), 'V' )
-!             CALL dom_vvl_interpol( e3u(:,:,:,Kmm), e3f(:,:,:), 'F' )
-!             ! Vertical scale factor interpolations
-!             ! ------------------------------------
-!             CALL dom_vvl_interpol( e3t(:,:,:,Kmm), e3w (:,:,:,Kmm), 'W'  )
-!             CALL dom_vvl_interpol( e3u(:,:,:,Kmm), e3uw(:,:,:,Kmm), 'UW' )
-!             CALL dom_vvl_interpol( e3v(:,:,:,Kmm), e3vw(:,:,:,Kmm), 'VW' )
-!             CALL dom_vvl_interpol( e3u(:,:,:,Kbb), e3uw(:,:,:,Kbb), 'UW' )
-!             CALL dom_vvl_interpol( e3v(:,:,:,Kbb), e3vw(:,:,:,Kbb), 'VW' )
-!             ! t- and w- points depth
-!             ! ----------------------
-!             !!gm not sure of that....
-!             gdept(:,:,1,Kmm) = 0.5_wp * e3w(:,:,1,Kmm)
-!             gdepw(:,:,1,Kmm) = 0.0_wp
-!             gde3w(:,:,1) = gdept(:,:,1,Kmm) - ssh(:,:,Kmm)
-!             DO jk = 2, jpk
-!                gdept(:,:,jk,Kmm) = gdept(:,:,jk-1,Kmm) + e3w(:,:,jk  ,Kmm)
-!                gdepw(:,:,jk,Kmm) = gdepw(:,:,jk-1,Kmm) + e3t(:,:,jk-1,Kmm)
-!                gde3w(:,:,jk) = gdept(:,:,jk  ,Kmm) - ssh (:,:,Kmm)
-!             END DO
-!          ENDIF
+#endif
+
       ENDIF
 
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_oce_interp.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_oce_interp.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_oce_interp.F90	(revision 14062)
@@ -28,5 +28,5 @@
    USE agrif_oce
    USE phycst
-   USE dynspg_ts, ONLY: un_adv, vn_adv
+!!!   USE dynspg_ts, ONLY: un_adv, vn_adv
    !
    USE in_out_manager
@@ -50,5 +50,6 @@
    INTEGER ::   bdy_tinterp = 0
 
-   !!----------------------------------------------------------------------
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
    !! NEMO/NST 4.0 , NEMO Consortium (2018)
    !! $Id$
@@ -1192,9 +1193,9 @@
       !!----------------------------------------------------------------------  
       IF( before ) THEN
-         IF ( ln_bt_fw ) THEN
+!         IF ( ln_bt_fw ) THEN
             ptab(i1:i2,j1:j2) = e2u(i1:i2,j1:j2) * ub2_b(i1:i2,j1:j2)
-         ELSE
-            ptab(i1:i2,j1:j2) = e2u(i1:i2,j1:j2) * un_adv(i1:i2,j1:j2)
-         ENDIF
+!         ELSE
+!            ptab(i1:i2,j1:j2) = e2u(i1:i2,j1:j2) * un_adv(i1:i2,j1:j2)
+!         ENDIF
       ELSE
          zrhot = Agrif_rhot()
@@ -1228,9 +1229,9 @@
       !
       IF( before ) THEN
-         IF ( ln_bt_fw ) THEN
+!         IF ( ln_bt_fw ) THEN
             ptab(i1:i2,j1:j2) = e1v(i1:i2,j1:j2) * vb2_b(i1:i2,j1:j2)
-         ELSE
-            ptab(i1:i2,j1:j2) = e1v(i1:i2,j1:j2) * vn_adv(i1:i2,j1:j2)
-         ENDIF
+!         ELSE
+!            ptab(i1:i2,j1:j2) = e1v(i1:i2,j1:j2) * vn_adv(i1:i2,j1:j2)
+!         ENDIF
       ELSE      
          zrhot = Agrif_rhot()
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_oce_sponge.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_oce_sponge.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_oce_sponge.F90	(revision 14062)
@@ -32,4 +32,5 @@
 
    !! * Substitutions
+#  include "domzgr_substitute.h90"
 #  include "do_loop_substitute.h90"
    !!----------------------------------------------------------------------
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_oce_update.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_oce_update.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_oce_update.F90	(revision 14062)
@@ -27,5 +27,7 @@
    USE vremap         ! Vertical remapping
    USE lbclnk 
-
+#if defined key_qco
+   USE domqco
+#endif
    IMPLICIT NONE
    PRIVATE
@@ -34,4 +36,6 @@
    PUBLIC   Update_Scales
 
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/NST 4.0 , NEMO Consortium (2018)
@@ -191,5 +195,4 @@
    END SUBROUTINE Agrif_Update_Tke
 
-
    SUBROUTINE Agrif_Update_vvl( )
       !!---------------------------------------------
@@ -201,4 +204,5 @@
       IF (lwp.AND.lk_agrif_debug) Write(*,*) 'Update e3 from grid Number',Agrif_Fixed(), 'Step', Agrif_Nb_Step()
       !
+#if ! defined key_qco
       Agrif_UseSpecialValueInUpdate = .TRUE.
       Agrif_SpecialValueFineGrid = 0.
@@ -213,7 +217,32 @@
       CALL dom_vvl_update_UVF
       CALL Agrif_ParentGrid_To_ChildGrid()
+#else
+      CALL Agrif_ChildGrid_To_ParentGrid()
+      CALL Agrif_Update_qco
+      CALL Agrif_ParentGrid_To_ChildGrid()
+#endif
       !
    END SUBROUTINE Agrif_Update_vvl
 
+
+#if defined key_qco
+   SUBROUTINE Agrif_Update_qco
+      !!---------------------------------------------
+      !!       *** ROUTINE dom_Update_qco ***
+      !!---------------------------------------------
+      !
+      ! Save arrays prior update (needed for asselin correction)
+      r3t(:,:,Krhs_a) = r3t(:,:,Kmm_a)
+      r3u(:,:,Krhs_a) = r3u(:,:,Kmm_a)
+      r3v(:,:,Krhs_a) = r3v(:,:,Kmm_a)
+
+      ! Update r3x arrays from updated ssh
+      CALL dom_qco_zgr( Kbb_a, Kmm_a )
+      !
+   END SUBROUTINE Agrif_Update_qco
+#endif
+
+
+#if ! defined key_qco
    SUBROUTINE dom_vvl_update_UVF
       !!---------------------------------------------
@@ -224,5 +253,4 @@
       REAL(wp):: zcoef
       !!---------------------------------------------
-
       IF (lwp.AND.lk_agrif_debug) Write(*,*) 'Finalize e3 on grid Number', &
                   & Agrif_Fixed(), 'Step', Agrif_Nb_Step()
@@ -290,4 +318,5 @@
       !
    END SUBROUTINE dom_vvl_update_UVF
+#endif
 
 #if defined key_vertical
@@ -1336,4 +1365,5 @@
    END SUBROUTINE updateAVM
 
+#if ! defined key_qco
    SUBROUTINE updatee3t(ptab_dum, i1, i2, j1, j2, k1, k2, before )
       !!---------------------------------------------
@@ -1447,4 +1477,5 @@
       !
    END SUBROUTINE updatee3t
+#endif
 
 #else
Index: NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_user.F90
===================================================================
--- NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_user.F90	(revision 14059)
+++ NEMO/branches/2020/dev_r13333_KERNEL-08_techene_gm_HPG_SPG/src/NST/agrif_user.F90	(revision 14062)
@@ -288,4 +288,5 @@
          CALL Agrif_Init_Variable(sshini_id, procname=agrif_initssh)
          CALL lbc_lnk( 'Agrif_Init_Domain', ssh(:,:,Kbb), 'T', 1. )
+#if ! defined key_qco
          DO jk = 1, jpk
                e3t(:,:,jk,Kbb) =  e3t_0(:,:,jk) * ( ht_0(:,:) + ssh(:,:,Kbb)  ) &
@@ -293,4 +294,5 @@
                         &              + e3t_0(:,:,jk) * ( 1._wp - tmask(:,:,jk) )
          END DO
+#endif
       ENDIF
 
